function varargout = a(varargin)
% A Application M-file for a.fig
%    FIG = A launch a GUI.
%    A('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 14-Feb-2005 09:34:58

if nargin == 0  % LAUNCH GUI

	fig = openfig(mfilename,'reuse');

	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
    guidata(fig, handles);

	if nargout > 0
		varargout{1} = fig;
	end

elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK

	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end

end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.





%Vse co je nad si generuje matlab sam a lisi se to podle verze, kterou 
%prave pouzivate, hlavicky funkci ktere jsou dale by si mel generuvat take sam,
%ale muzete si je i vytvorit. Chovani celku je vsak podobne. Pro sdileni vlastnich
%dat mezi jednotlivymi funkcemi slouzi parametr varargin a varargout. Zde je na
%ukazku pouzito struktury handles pro ulozeni vlastnich dat
%mozno pouzivat i globalni promenne napr.:
%>>delka= 50;
%>>global delka
%a promenna delka by mela byt videt i v callback funkcich



% --------------------------------------------------------------------
function varargout = figure1_CreateFcn(h, eventdata, handles, varargin)
%Tato funkce je volana pri vytvoreni naseho programu (nas dialog ma jmeno figure1)
%ostatni prvky na nem posazene vsak v tuto chvili pravdepodobne jeste neexistuji
%handles je prazdny, a tudiz je zde nemuzeme hromadne inicializovat na pocatecni hodnotu
%resenim je reagovat na udalosti kazdeho naseho prvku: mujprvek_CreateFcn(.... a pak ho inicialoizovat samostatne
%vzdy 1. parametr (v teto verzi matlabu je automaticky pojmenovavan jako h) je id primo prvku, nad kterym je udalost
%zavolana
%Proto zde muzeme volat napr. set(h,'Resize','on') pro umozneni zmeni velikosti celeno okna


% --------------------------------------------------------------------
function varargout = pushbutton1_Callback(h, eventdata, handles, varargin)
%prikaz pro ziskani souradnic z libovolneno obrazku ci grafu
%ceka na stisk tlacitka, mozdo i detekce, ktere tlacitko bylo stisknuto
[x,y]= ginput(1)
%prikaz set nastavi libovolnou hodnotu struktury vlastnosti vybraneho ovladaciho prvku
%pristup ke vsem provkum je pres handles.jmeno_prvku (1. parametr)
%kterou vlastnost chceme menit urcime 2.parametrem
%3. parametr je hodnota v prislusnem datovem tzpu
set(handles.edit1,'String',sprintf('x=%d y=%d',round(x),round(y)));

% --------------------------------------------------------------------
function varargout = FILE_Callback(h, eventdata, handles, varargin)



% --------------------------------------------------------------------
function varargout = FILE_OPEN_Callback(h, eventdata, handles, varargin)

%volani dialogu pro vyber souboru, nastaveni libovolnych filtru
[filename, pathname] = uigetfile({'*.jpg;*.tif','Picture files (*.jpg,*.tif)';'*.jpg','JPEG (*.jpg)'}, 'Open file');
%test existence vybraneho ci zadaneho souboru
if isequal(filename,0)|isequal(pathname,0)
    %disp('File not found')
else
    %disp(['File ', pathname, filename, ' found'])
    filename = fullfile(pathname,filename);
    %nacteni obrazku
    im= imread(filename);    
    %ulozime si i sedotonouvou reprezentaci
    g= rgb2gray(im);
    %volani vlastni funkce
    th= 100;
    bw= threshold(g,th);
    
    %libovolne nasteveni viditelnosti a povoleni prvku
    %stejny postup> set(.....
    set(handles.slider1,'Value',th);
    set(handles.slider1,'Enable','On');
    set(handles.radiobutton1,'Enable','On');
    set(handles.radiobutton1,'Value',0);
    set(handles.axes3,'Visible','On');
    set(handles.axes4,'Visible','On');
    %nastaveni statickeho textu
    set(handles.text2,'String',sprintf('%d',th));
    %ulozeni dat do handles
    handles.im= im;
    handles.g= g;
    handles.bw= bw;
    %a jejich update
    guidata(handles.figure1,handles);
    %vyber figur pro vykresleni, je-li jen jedna, nemusi se delat
    axes(handles.axes3);
    imshow(handles.im);
    axes(handles.axes4);
    imshow(handles.bw);
end


% --------------------------------------------------------------------
function varargout = FILE_CLOSE_Callback(h, eventdata, handles, varargin)

%horni Menu se chova stejne jako ostatni prvky
handles.im= [];
handles.g= [];
handles.bw= [];
guidata(handles.figure1,handles);

set(handles.slider1,'Enable','Off');
set(handles.radiobutton1,'Enable','Off');

set(handles.axes3,'Visible','Off');
set(handles.axes4,'Visible','Off');



% --------------------------------------------------------------------
function varargout = slider1_Callback(h, eventdata, handles, varargin)

%krom callback udalosti, ktera se vola pro kazde zmene provedene uzivatelem
%nad danym provkem, muzeme reagovat i na dalsi predefinovane udalosti

%ziskani hodnoty posuvniku a ulozeni do lokalni promenne
%ziskani nodnoty vybraneho prvku se porvadi pres funkci get(....
%stejne postup jako u set  (chybi posledni parameter, ale vraci nami zvolenou hodnotu)
th= round(get(handles.slider1,'Value'));
%volani vlastni funkce
handles.bw= threshold(handles.g,th);
%ulozime handles do domovske figury, drive nez zkonci callback
guidata(handles.figure1,handles);
%nastav staticky text
set(handles.text2,'String',sprintf('%d',th));
%nastav misto kam vykreslit obrazek
axes(handles.axes4);
%vykresleni
imshow(handles.bw);


% --------------------------------------------------------------------
function varargout = radiobutton1_Callback(h, eventdata, handles, varargin)

%struktura prvku radiobutton ma v promenne Value hodnotu 0 nebo 1 podle aktualniho stavu
%podobne se bude chovat i zaskrtavaci policko
axes(handles.axes3);
if get(h,'Value')==0
    imshow(handles.im);
else
    imshow(handles.g);
end
    
    


% --------------------------------------------------------------------
function varargout = edit1_Callback(h, eventdata, handles, varargin)

%dalsi prvky a detailnejsi studovani jejich chovani jiz nacham na vasi tvorivosti